((level SOL_SOCKET
        (SO_ACCEPTCONN bool get)
        (SO_BROADCAST bool get/set)
        (SO_DEBUG bool get/set)
        (SO_DONTROUTE bool get/set)
        (SO_ERROR int get)
        (SO_KEEPALIVE bool get/set)
        (SO_OOBLINE bool get/set)
        (SO_PASSCRED bool get/set)
        (SO_RCVBUF int get/set)
        (SO_SNDBUF int get/set)
        (SO_RCVLOWAT int get/set)
        (SO_SNDLOWAT int get/set)
        (SO_RCVTIMEO timeval get/set)
        (SO_SNDTIMEO timeval get/set)
        (SO_REUSEADDR bool get/set)
        (SO_REUSEPORT bool get/set)
        (SO_TYPE int get)
        (SO_TIMESTAMP bool get/set)
        (SO_USELOOPBACK bool get/set))
 (level IPPROTO_IP
        (IP_ADD_MEMBERSHIP ip_mreq set)
        (IP_DROP_MEMBERSHIP ip_mreq set)
        (IP_HDRINCL bool get/set)
        (IP_MTU int get/set)
        (IP_MTU_DISCOVER int get/set)
        (IP_MULTICAST_IF in_addr get/set)
        (IP_MULTICAST_LOOP bool get/set)
        (IP_MULTICAST_TTL int get/set)
        (IP_OPTIONS (bytes 40) get/set)
        (IP_PKTINFO bool get/set)
        (IP_RECVDSTADDR bool get/set)
        (IP_RECVIF bool get/set)
        (IP_RECVTOS bool get/set)
        (IP_RECVTTL bool get/set)
        (IP_TOS int get/set)
        (IP_TTL int get/set))
 (level IPPROTO_IPV6
        (IPV6_ADD_MEMBERSHIP ipv6_mreq set)
        (IPV6_DROP_MEMBERSHIP ipv6_mreq set)
        (IPV6_MULTICAST_HOPS int get/set)
        (IPV6_MULTICAST_IF in6_addr get/set)
        (IPV6_MULTICAST_LOOP bool get/set)
        (IPV6_MTU int get/set)
        (IPV6_MTU_DISCOVER int get/set)
        (IPV6_CHECKSUM int get/set)
        (IPV6_PKTINFO bool get/set)
        (IPV6_RECVERR bool get/set)
        (IPV6_UNICAST_HOPS int get/set)
        (IPV6_RTHDR bool get/set)
        (IPV6_AUTHHDR bool get/set)
        (IPV6_DSTOPTS bool get/set)
        (IPV6_HOPOPTS bool get/set)
        (IPV6_FLOWINFO bool get/set)
        (IPV6_HOPLIMIT bool get/set))
 (level IPPROTO_TCP
        (TCP_KEEPALIVE int get/set)
        (TCP_KEEPIDLE int get/set)
        (TCP_KEEPINTVL int get/set)
        (TCP_MAXRT int get/set)
        (TCP_MAXSEG int get/set)
        (TCP_NODELAY bool get/set)
        (TCP_SYNCNT int get/set))
 (const IP_PMTUDISC_WANT 
        IP_PMTUDISC_DONT
        IP_PMTUDISC_DO
        IPV6_PKTOPTIONS
        IPTOS_LOWDELAY
        IPTOS_THROUGHPUT
        IPTOS_RELIABILITY
        IPTOS_MINCOST
        MSG_DONTROUTE
        MSG_DONTWAIT
        MSG_MORE
        MSG_OOB))
